#include <bits/stdc++.h>
using namespace std;

const int MAXN = 2e3 + 3, MAXS = 2e4 + 3;

int s,n,a[MAXN],dp[MAXS],t;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>s>>n;

    for(int i=1;i<=n;i++){
        cin>>a[i];
        dp[a[i]]=1;
    }


    for(int i=1;i<s;i++){
        for(int j=1;j<=n;j++){
            t=i+a[j];
            if(dp[t]==0)dp[t]=dp[i]+1;
            else{
                dp[t]=min(dp[t],dp[i]+1);
            }
        }
    }



    cout<<dp[s];



    return 0;
}

